Unit ec21r_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure ec21r(var A :Array of Real; var X :Array of Real;
                var BA :Array of Real; var B :Array of Real;
                var C :Array of Real; N :Integer; T :Real; J1 :Integer;
                ALFA :Real);

implementation

procedure ec21r(var A :Array of Real; var X :Array of Real;
                var BA :Array of Real; var B :Array of Real;
                var C :Array of Real; N :Integer; T :Real; J1 :Integer;
                ALFA :Real);
var
I,J,K,KJ1,NI1,NJ2 :Integer;
A11,A12,B1,C1,FKK,H,RK,SK,U12,U1N :Real;
label
_10,_20,_30,_40,_50,_60,_70,_80;
begin
H := T/((N)-1.0);
if ( J1 > 0.5 ) 
 then goto _20;
for I:=1 to N do
 begin
  A[I-1] := H*H*A[I-1];
  BA[I-1] := H*BA[I-1];
_10:
 end;
A11 := A[0];
A12 := A[1];
_20:
A[1] := A12 - ALFA/H;
B1 := ALFA/H/2.0;
A[0] := A11 + ALFA/H*2.0;
C[0] := 1.0/A[0];
X[0] := BA[0]*C[0];
B[0] := 0.0;
for K:=2 to N do
 begin
  C[K-1] := 0.0;
  X[K-1] := 0.0;
  RK := 0.0;
  FKK := 0.0;
  for J:=2 to K do
   begin
    KJ1 := K - J + 1;
    B[J-1] := C[KJ1-1];
    RK := RK + A[J-1]*B[J-1];
    FKK := FKK + A[J-1]*X[KJ1-1];
_30:
   end;
  FKK := BA[K-1] - FKK;
  SK := 1.0/(1.0 - RK*RK);
  RK := -RK*SK;
  for J:=1 to K do
   begin
    KJ1 := K - J + 1;
    C[J-1] := C[J-1]*SK + B[J-1]*RK;
    X[KJ1-1] := X[KJ1-1] + C[J-1]*FKK;
_40:
   end;
_50:
 end;
FKK := 0.0;
for J:=2 to N do
 begin
  NJ2 := N - J + 2;
  FKK := FKK - A[J-1]*B[NJ2-1];
_60:
 end;
for J:=2 to N do
 begin
  NJ2 := N - J + 2;
  C[NJ2-1] := (B[J-1] + C[NJ2-1]*FKK)*B1;
_70:
 end;
C[0] := C[0]*FKK*B1;
C1 := IntPower(1.0 - C[1],2) - IntPower(C[N-2],2);
U12 := (X[1]*(1.0 - C[1]) + X[N-2]*C[N-2])/C1;
U1N := ((1.0 - C[1])*X[N-2] + X[1]*C[N-2])/C1;
for I:=1 to N do
 begin
  NI1 := N - I + 1;
  X[I-1] := U12*C[I-1] + U1N*C[NI1-1] + X[I-1];
_80:
 end;
X[0] := 2.0*X[0];
X[N-1] := 2.0*X[N-1];
end;

end.
